# Generated by Django 4.1.7 on 2023-03-22 12:19

import django.db.models.deletion
from django.db import connection, migrations, models


def point_history_items_at_volunteers(apps, schema_editor):
    apps.get_model("applications", "Application")
    Volunteer = apps.get_model("volunteers", "Volunteer")
    HistoryItem = apps.get_model("history", "HistoryItem")

    # if HistoryIte
    if (
        HistoryItem.objects.exclude(
            content_type__app_label="applications", content_type__model="application"
        )
        .exclude(content_type__app_label="volunteers", content_type__model="volunteer")
        .exists()
    ):
        raise AssertionError(
            "Expected all history items to point at applications or volunteers"
        )

    with connection.cursor() as cursor:
        cursor.execute(
            """
            UPDATE history_historyitem as hi
                SET volunteer_id = v.id
            FROM volunteers_volunteer as v
                JOIN django_content_type as ct
                ON
                    ct.app_label = 'volunteers'
                    AND ct.model = 'volunteer'
            WHERE
                hi.content_type_id = ct.id
                AND hi.object_id = v.id

            """
        )
        cursor.execute(
            """
            UPDATE history_historyitem as hi
                SET volunteer_id = v.id
            FROM applications_application as a
                  JOIN volunteers_volunteer as v
                    ON v.application_id = a.id
                  JOIN django_content_type as ct
                    ON ct.app_label = 'applications' AND ct.model = 'application'
            WHERE
                hi.content_type_id = ct.id
                AND hi.object_id = a.id

            """
        )
    for hi in HistoryItem.objects.all():
        match hi.content_type.model:
            case "application":
                if (
                    hi.volunteer_id
                    != Volunteer.objects.get(application_id=hi.object_id).id
                ):
                    raise Exception(
                        f"messed up link through application, hi id: {hi.id}"
                    )
            case "volunteer":
                if hi.volunteer_id != hi.object_id:
                    raise Exception(f"messed up link to volunteer, hi id: {hi.id}")
            case x:
                raise Exception(f"unexpected content type: {x}")


class Migration(migrations.Migration):
    dependencies = [
        ("applications", "0045_application_removal_4_prep_sarapplication"),
        ("history", "0002_alter_historyitem_id"),
    ]

    operations = [
        migrations.AddField(
            model_name="historyitem",
            name="volunteer",
            field=models.ForeignKey(
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                to="volunteers.volunteer",
            ),
        ),
        migrations.RunPython(point_history_items_at_volunteers),
        migrations.AlterField(
            model_name="historyitem",
            name="volunteer",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name="history",
                to="volunteers.volunteer",
            ),
        ),
        migrations.RemoveField(
            model_name="historyitem",
            name="content_type",
        ),
        migrations.RemoveField(
            model_name="historyitem",
            name="object_id",
        ),
    ]
